PROGRAM ALERT;

{  This Turbo Pascal V4.0 program sounds an alert tone until a key is
   pressed or until fifteen minutes have passed.

   Program by Harry M. Murphy,  1 March 1986.

   Updated for Turbo Pascal Version 4.0 on 23 November 1987. }

USES
      CRT;

CONST
      DUR = 50;
      HI  = 1056;
      LO  = 528;
      MAX = 15;
      SP  = '     ';

VAR
    CH : CHAR;
    I  : BYTE;
    M  : BYTE;
    N  : BYTE;

{ -------------------------------- }

PROCEDURE PAUSE(N : INTEGER);

VAR
    I : INTEGER;

BEGIN
  I := N;
  REPEAT
    DELAY(100);
    I := I-1
  UNTIL KEYPRESSED OR (I=0)
END { Procedure PAUSE };

{ -------------------------------- }

BEGIN { Program ALERT }
  TEXTCOLOR(30);
  TEXTBACKGROUND(0);
  WRITE(SP,'PRESS ANY KEY TO STOP THIS ALERT.',SP,#13);
  NORMVIDEO;
  M := MAX;
  REPEAT
    N := 5;
    REPEAT
      FOR I:=1 TO 10 DO
        BEGIN
          SOUND(LO);
          DELAY(DUR);
          SOUND(HI);
          DELAY(DUR)
        END;
      NOSOUND;
      PAUSE(10);
      N := N-1
    UNTIL KEYPRESSED OR (N=0);
    PAUSE (500);
    M := M-1
  UNTIL KEYPRESSED OR (M=0);
  WHILE KEYPRESSED DO CH := READKEY;
  CLREOL;
  WRITELN(SP,'ALERT cancelled.');
  SOUND(LO);
  DELAY(100);
  NOSOUND
END.
