	PAGE	54,132
	TITLE	Mark Time Program.
;
;	This program marks the current time, in seconds since midnight,
;       for subsequent use by the RUNTIM program.
;
;	This routine stores the current time in the  Intra-Application
;	Communications Area, memory locations 0:04FA through 0:04FF.
;
;	Program by Harry M. Murphy,  21 August 1986.
;
	DOS  = 21h		;DOS interrupt code.
	MARK = 4B4DH		;Mark code, "MK".
;
MRKTIM	SEGMENT	'CODE'
ASSUME	CS:MRKTIM,DS:NOTHING
MKT:	MOV	AH,2CH		;Call DOS for
	INT	DOS		;  current time in CX and DX.
	XOR	AX,AX		;Set Data Segment
	MOV	DS,AX		;  to point to the zero segment.
	MOV	DS:04FAH,DX	;Save DX, CX and MARK in
	MOV	DS:04FCH,CX	;  04FAH through 04FFh of the
	MOV	DS:04FEH,MARK	;    I-A Comm Area.
	MOV	AX,4C00H	;Call DOS to
	INT	DOS		;  stop the process.
MRKTIM	ENDS
	END	MKT
